unit dInvoices;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, Forms, Controls,  DBase, db;

type

  { TDMInvoices }

  TDMInvoices = class(TDMBase)
    SQLInvoices: TSQLQuery;
    SQLInvoiceEdit: TSQLQuery;
    SQLInvoicelines: TSQLQuery;
    SQLInvoiceLinesEdit: TSQLQuery;
    TrInvoices: TSQLTransaction;
    TrInvoiceEdit: TSQLTransaction;
    TrInvoicelines: TSQLTransaction;
    TrInvoiceLinesEdit: TSQLTransaction;
  private

  public
    procedure GetDeelnemerInfo(const id: integer; var aNaam : string);

    function GetFactuurnr : integer;
  end;

implementation

{$R *.lfm}

uses dConnections;

procedure TDMInvoices.GetDeelnemerInfo(const id: integer; var aNaam : string);
var SQLQuery    : TSQLQuery;
    Transaction : TSQLTransaction;
begin
  SQLQuery    := TSQLQuery.create(nil);
  Transaction := TSQLTransaction.create(SQLQuery);
  try
    SQLQuery.DataBase    := DMConnections.DBConnection;
    Transaction.DataBase := DMConnections.DBConnection;;
    SQLQuery.Transaction := Transaction;
    with SQLQuery.SQL do
    begin
      Add('SELECT company FROM customers WHERE id = :ID');
    end;
    SQLQuery.Params[0].AsInteger := id;
    SQLQuery.Active:= true;
    aNaam := SQLQuery.fieldbyname('company').AsString;
    Transaction.commit;
  finally
    SQLQuery.free;
  end;
end;

function TDMInvoices.GetFactuurnr: integer;
var SQLQuery    : TSQLQuery;
    Transaction : TSQLTransaction;
    Waarde      : integer;
begin
  SQLQuery    := TSQLQuery.create(nil);
  Transaction := TSQLTransaction.create(SQLQuery);
  try
    SQLQuery.DataBase    := DMConnections.DBConnection;
    Transaction.DataBase := DMConnections.DBConnection;;
    SQLQuery.Transaction := Transaction;
    with SQLQuery.SQL do
      Add('SELECT id, defvalue FROM defaults WHERE deflable = :label');
    SQLQuery.Params[0].AsString := 'INVOICENO';
    SQLQuery.Active:= true;
    if SQLQuery.RecordCount > 0 then
    begin
      waarde := StrToInt(SQLQuery.FieldByName('defvalue').AsString);
      result := waarde;
      waarde := waarde + 1;
      SQLQuery.Edit;
      SQLQuery.FieldByName('defvalue').AsString := IntToStr(Waarde);
      SQLQuery.Post;
    end else
      result := 1;
    SQLQuery.ApplyUpdates;
    Transaction.commit;
  finally
    SQLQuery.free;
  end;

end;


end.

