unit clcostumeredit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, clBase, dcustomers, clLazGlobals, DBCtrls,
  dlookups, Forms, dialogs;

type

{ Tcustomeredit }

 Tcustomeredit = class(TBase)
 private
   FDMLookups : TDMLookups;
   function GetModule: TDMCustomers;

  public
    constructor Create; override;
    destructor  Destroy; override;

    procedure LookupConnect(Combobox: TDBLookupComboBox; const SourceName: string);
    procedure NawSave;

    function Init(Ds1 : TDatasource) : boolean;

    property Datamodule : TDMCustomers read GetModule;
end;

implementation

{ Tcustomeredit }

constructor Tcustomeredit.Create;
begin
  inherited Create;
  CreateDMModule(TDMCustomers);
  FDMLookups := TDMLookups.create(nil);
end;

destructor Tcustomeredit.Destroy;
begin
  FDMLookups.free;  // <-- dit wordt eerder uitgevoerd, waardoor mijn andere tabllen worden afgesloten
  datamodule.free;
  inherited Destroy;
end;

function Tcustomeredit.Init(Ds1: TDatasource): boolean;
begin
  fCurrentdataset  := datamodule.SQLcustomersedit ;
  datamodule.SQLcustomersedit.Transaction := datamodule.Trcustomersedit;
  if fCurrentdataset <> nil then
  begin
    datamodule.SQLcustomersedit.Params[0].AsInteger := uGlobal.GetvarInt('CUSTOMER_ID');
    Ds1.dataset            := fCurrentdataset;
    fCurrentdataset.Active := true;
    fcurrentdataset.FieldByName('ID').Required := false;
    result := true;
  end else
    result := false;
end;

function Tcustomeredit.GetModule: TDMCustomers;
begin
  result := TDMCustomers(inherited datamodule)
end;

procedure Tcustomeredit.LookupConnect(Combobox : TDBLookupComboBox; const SourceName : string);
begin
  FDMLookups.Connect(ComboBox,SourceName);
end;

procedure Tcustomeredit.NawSave;
begin
  RecordPost;
end;

end.

