unit clcustomers;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, variants, dialogs, clBase, dcustomers, clLazGlobals,
  {, bufdataset,}
  clLazFunctions ,sqlDB, clMyTypes;

type

 { TCustomers }

 TCustomers = class(TBase)
 private
   fRGExport         : smallint;
   function GetModule: TDMcustomers;
  protected
  public
    constructor Create; override;
    destructor  Destroy; override;

    function Init(Ds1 : TDatasource) : boolean;

    procedure StartCustomerEdit(const aNew : boolean);
    procedure returnvar;

    property Datamodule : TDMcustomers read GetModule;
    property RGExport   : smallint read fRGExport write fRGExport;
end;

implementation

{ TCustomers }

uses dConnections;

constructor TCustomers.Create;
begin
  inherited Create;
  CreateDMModule(TDMcustomers);
end;

destructor TCustomers.Destroy;
begin
  datamodule.free;
  inherited Destroy;
end;

function TCustomers.Init(Ds1: TDatasource): boolean;
begin
  datamodule.SQLcustomers.database    := DMConnections.DBConnection;
  datamodule.Trcustomers.DataBase     := DMConnections.DBConnection;
  datamodule.SQLcustomers.Transaction := datamodule.Trcustomers;
  fCurrentdataset  := datamodule.SQLcustomers;
  if fCurrentdataset <> nil then
  begin
    Ds1.dataset            := fCurrentdataset;
    fCurrentdataset.Active := true;
    fcurrentdataset.FieldByName('ID').Required := false;
    result := true;
  end else
    result := false;
end;

procedure TCustomers.StartCustomerEdit(const aNew: boolean);
begin
  try
    fCurrentdataset.disablecontrols;
    if aNew then
      uGlobal.PutInt('CUSTOMER_ID',-1)
    else
      uGlobal.PutInt('CUSTOMER_ID',fCurrentdataset.fieldbyname('id').AsInteger);
    NextForm('FrmCustomersedit', nxcenter);
    fcurrentdataset.refresh;
    fcurrentdataset.Locate('id',vararrayof([uGlobal.GetVarInt('CUSTOMER_ID')]),[])
  finally
    fCurrentdataset.enablecontrols;
    uGlobal.Remove('CUSTOMER_ID');
  end;
end;

procedure TCustomers.returnvar;
begin
  if uGlobal.GetvarBool('EMB_CUSTOMERLIST') then
    uGlobal.Put('RETURNVAR',FCurrentDataset.fieldbyname('ID').AsString);
end;

function TCustomers.GetModule: TDMcustomers;
begin
  result := TDMcustomers(inherited datamodule)
end;

end.

