unit clInvoiceEdit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, clBase, dInvoices, clLazGlobals, DBCtrls, stdctrls,
  clLazFunctions, clMyTypes, clInvoicepr, comCtrls;

type

{ TInvoiceedit }

 TInvoiceedit = class(TBase)
 private
   procedure DisplayInvoiceLines;
   function GetModule: TDMInvoices;
  public
    FFactuurItems : TListItems;

    constructor Create; override;
    destructor  Destroy; override;

    procedure NawSave;
    procedure isRecordsEmpty(acompanyname : TLabel);
    procedure StartInvoicelines;
    procedure print;

    function FindCustomer : string;

    function Init(Ds1 : TDatasource; aItems : TListItems) : boolean;

    property Datamodule : TDMInvoices read GetModule;
end;

implementation

{ TInvoiceedit }

constructor TInvoiceedit.Create;
begin
  inherited Create;
  CreateDMModule(TDMInvoices);
end;

destructor TInvoiceedit.Destroy;
begin
  datamodule.free;
  inherited Destroy;
end;

function TInvoiceedit.Init(Ds1 : TDatasource; aItems : TListItems): boolean;
begin
  FFactuurItems    := aItems;
  fCurrentdataset  := datamodule.SQLInvoiceEdit ;
  datamodule.SQLInvoiceEdit.Transaction := datamodule.TrInvoiceEdit;
  datamodule.SQLInvoiceLines.Transaction := datamodule.TrInvoiceLines;
  if fCurrentdataset <> nil then
  begin
    datamodule.SQLInvoiceEdit.Params[0].AsInteger := uGlobal.GetvarInt('INVOICE_ID');
    Ds1.dataset            := fCurrentdataset;
    fCurrentdataset.Active := true;
    fcurrentdataset.FieldByName('ID').Required := false;
    DisplayInvoiceLines;
    result := true;
  end else
    result := false;
end;

function TInvoiceedit.GetModule: TDMInvoices;
begin
  result := TDMInvoices(inherited datamodule)
end;

procedure TInvoiceedit.NawSave;
begin
  RecordPost;
end;

procedure TInvoiceedit.isRecordsEmpty(acompanyname : TLabel);
var naam : string;
begin
  if recordsEmpty then
  begin
    fcurrentdataset.FieldByName('invoicenumber').AsInteger := datamodule.GetFactuurnr;
    fcurrentdataset.fieldbyname('invoicedate').AsDateTime := date
  end else
  begin
    Datamodule.GetDeelnemerInfo(fCurrentdataset.FieldByName('customerid').AsInteger, Naam);
    acompanyname.caption := Naam;
  end;
end;

procedure TInvoiceedit.StartInvoicelines;
begin
  try
    uGlobal.PutInt('INVOICENO',fcurrentdataset.FieldByName('invoicenumber').AsInteger);
    nextform('FrmInvoicelines',nxCenter);
    DisplayInvoiceLines;
  finally
    uGlobal.Remove('INVOICENO');
  end;
end;

procedure TInvoiceedit.DisplayInvoiceLines;
var Item    : TListItem;
    dataset : TDataset;
begin
  dataset := datamodule.SQLInvoicelines;
  try
    dataset.DisableControls;
    dataset.Active := false;
    datamodule.SQLInvoicelines.Params[0].AsInteger := fCurrentdataset.fieldbyname('invoicenumber').AsInteger;
    dataset.Active := true;
    dataset.First;
    FFactuurItems.Clear;
    while not dataset.eof do
    begin
      Item := FFactuurItems.Add;
      Item.Caption := dataset.FieldByName('description').AsString ;
      Item.SubItems.Add(format('%8.2f',[dataset.FieldByName('invoiceamount').AsFloat]));
      Item.SubItems.Add(format('%8.2f',[dataset.FieldByName('vatamount').AsFloat]));
      Item.SubItems.Add(format('%8.2f',[dataset.FieldByName('total').AsFloat]));
      dataset.next;
    end;
  finally
    dataset.enablecontrols;
  end;
end;

procedure TInvoiceedit.print;
var Invoicepr    : TInvoicepr;
  begin
    if fcurrentdataset.RecordCount > 0 then
    begin
      Invoicepr := TInvoicepr.create(datamodule.DBConnection, 1,uGlobal.GetVar('DEF_REPORT'));
      try
        Invoicepr.Desinger := uGlobal.GetVarBool('DEF_DESIGNER');
        Invoicepr.Prepare(fcurrentdataset.fieldbyname('id').AsInteger ) ;
        Invoicepr.CreateBody;
        Invoicepr.Finish;
      finally
        Invoicepr.free;
      end;
    end;
end;

function TInvoiceedit.FindCustomer: string;
var Naam      : string;
begin
    try
      uGlobal.PutBool('EMB_CUSTOMERLIST',true);
      nextform('Frmcustomers');
      if uGlobal.Exists('RETURNVAR') then
      begin
        if (fCurrentdataset.State in [dsInsert]) then
        begin
          fCurrentdataset.FieldByName('customerid').AsInteger := StrToInt(uGlobal.GetVar('RETURNVAR'));
          Datamodule.GetDeelnemerInfo(fCurrentdataset.FieldByName('customerid').AsInteger, Naam);
          result := Naam;
        end;
      end;
    finally
      uGlobal.remove('EMB_CUSTOMERLIST,RETURNVAR');
    end;
end;

end.

