unit fdefaults;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, Forms, Controls, Dialogs, ComCtrls, ActnList,
  StdCtrls, EditBtn, fbase, clDefaults;

type

  { TFrmDefaults }

  TFrmDefaults = class(TFrmBase)
    BtnSave: TButton;
    CKRapportdesigner: TCheckBox;
    EInvoicenumber: TEdit;
    EBtnReportname: TEditButton;
    LblReportname: TLabel;
    LblInvoicenumber: TLabel;
    procedure BtnSaveClick(Sender: TObject);
    procedure CKRapportdesignerClick(Sender: TObject);
    procedure EBtnReportnameButtonClick(Sender: TObject);
    procedure EBtnReportnameChange(Sender: TObject);
    procedure EInvoicenumberChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    function Getlink: TDefaults;

  public
     property link : TDefaults read Getlink;
  end;

implementation

{$R *.lfm}

{ TFrmDefaults }

procedure TFrmDefaults.FormCreate(Sender: TObject);
begin
  inherited;
  CreateLink(TDefaults);
  Link.init(datasource1);
end;

procedure TFrmDefaults.FormShow(Sender: TObject);
begin
  EBtnReportname.Text      := link.Reportname;
  EInvoicenumber.Text       := IntToStr(link.Invoicenumber);
  CKRapportdesigner.Checked := link.Designer;
end;

procedure TFrmDefaults.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  CloseAction := caFree;
  Link.free;
end;

procedure TFrmDefaults.EBtnReportnameButtonClick(Sender: TObject);
var OpenD : TOpendialog;
begin
  OpenD := TOpendialog.create(nil);
  try
    Opend.Filter      := 'Fast Reports|*.fr3';
    Opend.FilterIndex := 0;
    if Opend.Execute then
      EBtnReportname.Text := Extractfilename(Opend.FileName) ;
  finally
    Opend.free;
  end;
end;

procedure TFrmDefaults.CKRapportdesignerClick(Sender: TObject);
begin
  link.Designer := CKRapportdesigner.Checked;
end;

procedure TFrmDefaults.BtnSaveClick(Sender: TObject);
begin
  link.save
end;

procedure TFrmDefaults.EBtnReportnameChange(Sender: TObject);
begin
  link.Reportname := EBtnReportname.Text;
end;

procedure TFrmDefaults.EInvoicenumberChange(Sender: TObject);
begin
  link.Invoicenumber := StrToInt(EInvoicenumber.Text);
end;

function TFrmDefaults.Getlink: TDefaults;
begin
  result := TDefaults(inherited link)
end;

initialization
  RegisterClass(TFrmDefaults);

finalization
  UnRegisterClass(TFrmDefaults);


end.

