unit FBase;

interface

uses
  SysUtils, Variants, Classes, db, Controls, Forms, Graphics,
  clBase, DBCtrls, DBGrids;

type

  { TFrmBase }

  TFrmBase = class(TForm)
    DataSource1: TDataSource;
  private
    { Private declarations }
    FLink : TBase;
    procedure ExpandLastGridField(Grid: TDBGrid);
  public
    { Public declarations }
    procedure CreateLink(LinkClass : TBaseLink);
    procedure SetRaamwerk;
    procedure ConfigGrid(aGrid : TDBGrid);

    property Link : TBase read FLink;
  end;

type TFrmBaseLink = class of TFrmBase;

implementation

{$R *.lfm}

{ TFrmBase }

procedure TFrmBase.CreateLink(LinkClass: TBaseLink);
begin
  if Linkclass <> nil then
    Flink.free;
  fLink := LinkClass.Create;
end;


procedure TFrmBase.SetRaamwerk;
var index    : integer;
    reqindex : integer;

procedure AddRequiredField(var reqindex : integer; const aField : string);
begin
  reqindex := reqindex + 1;
  setlength(link.fRequiredfields,reqindex);
  link.fRequiredfields[reqindex - 1] := aField;
end;

begin
  reqindex := 0;
  for index := 0 to ComponentCount - 1 do
  begin
    if Components[index] is TDBEdit then
    begin
      if TDBEdit(Components[index]).Field.Required then
      begin
        TDBEdit(Components[index]).Color := clYellow;
        AddRequiredField(reqindex, TDBEdit(Components[index]).Field.FieldName);
      end;
    end else
    if Components[index] is TDBLookupComboBox then
    begin
      if TDBLookupComboBox(Components[index]).Field.Required then
      begin
        TDBLookupComboBox(Components[index]).Color := clYellow;
        AddRequiredField(reqindex,TDBLookupComboBox(Components[index]).Field.FieldName);
      end;
    end;
  end;
end;

procedure TFrmBase.ConfigGrid(aGrid: TDBGrid);
begin
  aGrid.Options := [dgTitles,dgIndicator,dgColumnResize,dgColLines,dgRowLines,dgRowSelect];
  ExpandLastGridField(aGrid);
end;

procedure TFrmBase.ExpandLastGridField(Grid : TDBGrid);
var GridWidth, ColumnWidth : word;
    teller : smallint;
begin
  GridWidth := Grid.Width;
  ColumnWidth := 0;
  for teller := 0 to Grid.Columns.Count - 1 do
    ColumnWidth := ColumnWidth + Grid.Columns[teller].Width;
  if ColumnWidth < GridWidth then
    Grid.Columns[Grid.Columns.Count - 1].Width :=
      Grid.Columns[Grid.Columns.Count - 1].Width + (GridWidth - ColumnWidth - 37);
end;


end.
