unit fguibase;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, ComCtrls,
  ActnList, DB, FBase, clMyActions;

type

  { TFrmGUIbase }

  TFrmGUIbase = class(TFrmBase)
    acBtnAdd: TAction;
    acBtnModify: TAction;
    acBtnSave: TAction;
    acBtnDelete: TAction;
    acBtnPrior: TAction;
    acBtnNext: TAction;
    acBtnFind: TAction;
    acBtnCancel: TAction;
    BaseActionList: TActionList;
    ImgButtons: TImageList;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton10: TToolButton;
    ToolButton12: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    procedure acBtnAddExecute(Sender: TObject);
    procedure acBtnAddUpdate(Sender: TObject);
    procedure acBtnCancelExecute(Sender: TObject);
    procedure acBtnCancelUpdate(Sender: TObject);
    procedure acBtnDeleteExecute(Sender: TObject);
    procedure acBtnDeleteUpdate(Sender: TObject);
    procedure acBtnModifyExecute(Sender: TObject);
    procedure acBtnModifyUpdate(Sender: TObject);
    procedure acBtnNextExecute(Sender: TObject);
    procedure acBtnNextUpdate(Sender: TObject);
    procedure acBtnPriorExecute(Sender: TObject);
    procedure acBtnPriorUpdate(Sender: TObject);
    procedure acBtnSaveExecute(Sender: TObject);
    procedure acBtnSaveUpdate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    fMyActions : TMyActions;

  end;

var
  FrmGUIbase: TFrmGUIbase;

implementation

{$R *.lfm}

{ TFrmGUIbase }

procedure TFrmGUIbase.FormCreate(Sender: TObject);
begin
inherited;
  fMyActions := TMyActions.create;
  fMyActions.Actionlist := BaseActionList;
end;

procedure TFrmGUIbase.FormDestroy(Sender: TObject);
begin
  fMyActions.free;
end;

procedure TFrmGUIbase.acBtnAddExecute(Sender: TObject);
begin
  link.RecordNew
end;

procedure TFrmGUIbase.acBtnAddUpdate(Sender: TObject);
begin
  if datasource1.DataSet <> nil then
    TAction(Sender).Enabled := datasource1.State in [dsBrowse];
end;

procedure TFrmGUIbase.acBtnCancelExecute(Sender: TObject);
begin
  link.RecordCancel
end;

procedure TFrmGUIbase.acBtnCancelUpdate(Sender: TObject);
begin
  if datasource1.DataSet <> nil then
    TAction(Sender).Enabled := not (datasource1.State in [dsBrowse]);
end;

procedure TFrmGUIbase.acBtnDeleteExecute(Sender: TObject);
begin
  link.RecordDelete
end;

procedure TFrmGUIbase.acBtnDeleteUpdate(Sender: TObject);
begin
  if datasource1.DataSet <> nil then
    TAction(Sender).Enabled := datasource1.State in [dsBrowse];
end;

procedure TFrmGUIbase.acBtnModifyExecute(Sender: TObject);
begin
  link.StartFind
end;

procedure TFrmGUIbase.acBtnModifyUpdate(Sender: TObject);
begin
  tAction(Sender).Enabled := datasource1.state in [dsBrowse]
end;

procedure TFrmGUIbase.acBtnNextExecute(Sender: TObject);
begin
 if datasource1.DataSet <> nil then
    link.RecordNext
end;

procedure TFrmGUIbase.acBtnNextUpdate(Sender: TObject);
begin
 if datasource1.DataSet <> nil then
   tAction(Sender).Enabled := (Link.RecordNo < Link.RecordCount) and (Link.RecordCount > 1) and (datasource1.state in [dsBrowse])
end;

procedure TFrmGUIbase.acBtnPriorExecute(Sender: TObject);
begin
  if datasource1.DataSet <> nil then
    link.RecordPrior
end;

procedure TFrmGUIbase.acBtnPriorUpdate(Sender: TObject);
begin
  if datasource1.DataSet <> nil then
    tAction(Sender).Enabled := (Link.RecordNo > 1) and (datasource1.state in [dsBrowse])
end;

procedure TFrmGUIbase.acBtnSaveExecute(Sender: TObject);
begin
  link.RecordPost
end;

procedure TFrmGUIbase.acBtnSaveUpdate(Sender: TObject);
begin
  if datasource1.DataSet <> nil then
    TAction(Sender).Enabled := datasource1.State in [dsInsert,dsEdit];
end;

end.

